searchData={"items":[{"type":"module","title":"SqlMembershipProvider.Application","doc":"Struct for representing an application.","ref":"SqlMembershipProvider.Application.html"},{"type":"function","title":"SqlMembershipProvider.Application.find_by_application_id/1","doc":"Fetch an application by ID.","ref":"SqlMembershipProvider.Application.html#find_by_application_id/1"},{"type":"function","title":"SqlMembershipProvider.Application.find_by_application_name/1","doc":"Fetch an application by case-insensitive application name.","ref":"SqlMembershipProvider.Application.html#find_by_application_name/1"},{"type":"type","title":"SqlMembershipProvider.Application.t/0","doc":"","ref":"SqlMembershipProvider.Application.html#t:t/0"},{"type":"module","title":"SqlMembershipProvider.Membership","doc":"Struct for representing a user's membership to an application and their authentication information.","ref":"SqlMembershipProvider.Membership.html"},{"type":"function","title":"SqlMembershipProvider.Membership.create_changeset/2","doc":"Changeset for user registration","ref":"SqlMembershipProvider.Membership.html#create_changeset/2"},{"type":"function","title":"SqlMembershipProvider.Membership.find_by_email/2","doc":"Fetch a membership by case insensitive email address and case insensitive application name","ref":"SqlMembershipProvider.Membership.html#find_by_email/2"},{"type":"function","title":"SqlMembershipProvider.Membership.find_by_user_id/1","doc":"Fetch a membership by user id.","ref":"SqlMembershipProvider.Membership.html#find_by_user_id/1"},{"type":"function","title":"SqlMembershipProvider.Membership.is_password_valid?/2","doc":"Check if a plaintext password matches a user's hashed password.","ref":"SqlMembershipProvider.Membership.html#is_password_valid?/2"},{"type":"function","title":"SqlMembershipProvider.Membership.password_reset_changeset/2","doc":"Changeset for resetting user password. This method has no authentication checks.","ref":"SqlMembershipProvider.Membership.html#password_reset_changeset/2"},{"type":"function","title":"SqlMembershipProvider.Membership.password_update_changeset/2","doc":"Changeset for changing user password authenticated by the current password","ref":"SqlMembershipProvider.Membership.html#password_update_changeset/2"},{"type":"type","title":"SqlMembershipProvider.Membership.t/0","doc":"","ref":"SqlMembershipProvider.Membership.html#t:t/0"},{"type":"module","title":"SqlMembershipProvider.Profile","doc":"Struct for representing a user's profile information that may contain arbitrary properties","ref":"SqlMembershipProvider.Profile.html"},{"type":"function","title":"SqlMembershipProvider.Profile.create_changeset/2","doc":"Changeset for user registration","ref":"SqlMembershipProvider.Profile.html#create_changeset/2"},{"type":"function","title":"SqlMembershipProvider.Profile.find_by_user_id/1","doc":"Fetch a profile by user id.","ref":"SqlMembershipProvider.Profile.html#find_by_user_id/1"},{"type":"function","title":"SqlMembershipProvider.Profile.generate_properties/1","doc":"","ref":"SqlMembershipProvider.Profile.html#generate_properties/1"},{"type":"function","title":"SqlMembershipProvider.Profile.properties/1","doc":"Parse a profile's property fields into a map.","ref":"SqlMembershipProvider.Profile.html#properties/1"},{"type":"type","title":"SqlMembershipProvider.Profile.t/0","doc":"","ref":"SqlMembershipProvider.Profile.html#t:t/0"},{"type":"module","title":"SqlMembershipProvider.Role","doc":"Struct for representing a security role that a user may assume","ref":"SqlMembershipProvider.Role.html"},{"type":"function","title":"SqlMembershipProvider.Role.find_by_user_id/1","doc":"Fetch all roles that a user belongs to.","ref":"SqlMembershipProvider.Role.html#find_by_user_id/1"},{"type":"type","title":"SqlMembershipProvider.Role.t/0","doc":"","ref":"SqlMembershipProvider.Role.html#t:t/0"},{"type":"module","title":"SqlMembershipProvider.User","doc":"Struct for representing a user.","ref":"SqlMembershipProvider.User.html"},{"type":"function","title":"SqlMembershipProvider.User.create_changeset/2","doc":"Changeset for user registration","ref":"SqlMembershipProvider.User.html#create_changeset/2"},{"type":"function","title":"SqlMembershipProvider.User.find_by_user_id/1","doc":"Fetch a user by user ID.","ref":"SqlMembershipProvider.User.html#find_by_user_id/1"},{"type":"function","title":"SqlMembershipProvider.User.find_by_user_name/2","doc":"Fetch a user by case-insensitive username and case-insensitive application name.","ref":"SqlMembershipProvider.User.html#find_by_user_name/2"},{"type":"type","title":"SqlMembershipProvider.User.t/0","doc":"","ref":"SqlMembershipProvider.User.html#t:t/0"},{"type":"exception","title":"SqlMembershipProvider.UnsupportedPasswordFormatError","doc":"","ref":"SqlMembershipProvider.UnsupportedPasswordFormatError.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.9.1] - 2024-04-25","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- User.create_changeset/2 now has cast_assoc for Profile.create_changeset/2","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Incorrect param parsing for profile.create_changeset/2 \n\n## [0.9.1] - 2024-04-24","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Profile.create_changeset/2","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated TDS dependency\n\n## [0.9.0] - 2023-04-28","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies\n\n## [0.8.1] - 2021-10-19","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- credo & dialyzer static analysis tools","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Incorrect typespecs for map arguments\n\n## [0.8.0] - 2021-10-19","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- User.find_by_user_name/1\n\n## [0.7.0] - 2021-09-20","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- Membership.password_reset_changeset/2\n\n## [0.6.0] - 2021-09-20","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Membership.password_update_changeset/2\n\n## [0.5.0] - 2021-09-16","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- User.create_changeset/2\n - Membership.create_changeset/2\n - These methods are used for creating new registration changesets\n\n## [0.4.2] - 2021-08-05","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies\n\n## [0.4.1] - 2021-08-05","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated mix lockfile\n\n## [0.4.0] - 2021-08-05","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Membership.find_by_email/2 that accepts a case insensitive email address and application name\n\n## [0.3.2] - 2020-10-06","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies\n- Use typed_ecto_schema to reduce boilerplate\n\n## [0.3.1] - 2020-10-06","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- User.find_by_user_name/2 that accepts an application name. This lets\nyou distinguish between users with the same username on different applications.\n\n# Deprecated\n- User.find_by_user_name/1 which could return multiple users with the same\n  username, but different applications. Use User.find_by_user_name/2 instead.\n\n## [0.3.0] - 2020-09-25","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Convert library to use Ecto. All structs are now Ecto schemas, and `find_*`\n  functions return Ecto.Query which you must pass to a Ecto.Repo to get results.","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- Removed the SqlMembershipProvider.TdsUtils module because Ecto takes care of\n  these things for us.\n\n## [0.2.0] - 2020-09-11","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated dependencies\n\n## [0.1.2] - 2020-03-11","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- User.find_by_user_id/2\n\n## [0.1.1] - 2019-08-23","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Allow `nil` field values to pass through `TdsUtils.stringify_uuids/2` without error.\n\n## [0.1.0] - 2019-08-09","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release","ref":"changelog.html#added"},{"type":"extras","title":"SqlMembershipProvider","doc":"# SqlMembershipProvider\n\n[Hex.pm](https://hex.pm/packages/sql_membership_provider) [Documentation](https://hexdocs.pm/sql_membership_provider/)\n\nRead and authenticate against ASP.NET Membership Microsoft SQL Server databases.\n\nDo you have an ASP.NET app that uses the built-in Membership Provider that\nstores users, passwords, roles, and profiles in a Microsoft SQL Server database?\n\nThis library lets your Elixir code talk to a Membership Provider database to lookup users, their profile information roles they belong to, and authenticate their passwords.\n\nThis library uses [Tds](https://hex.pm/packages/tds) and [Ecto](https://hex.pm/packages/ecto) to connect to a Microsoft SQL Server database.","ref":"readme.html"},{"type":"extras","title":"Usage - SqlMembershipProvider","doc":"First you must define an [Ecto.Repo](https://hexdocs.pm/ecto/Ecto.Repo.html) to connect to the MSSQL database:\n\n```Elixir\ndefmodule MyApp.Repo do\n  use Ecto.Repo,\n    otp_app: :my_app,\n    adapter: Ecto.Adapters.Tds\nend\n```\n\nMake sure to configure your database credentials:\n\n```elixir\nconfig :my_app, MyApp.Repo,\n  database: \"aspnetdb\",\n  hostname: \"localhost\",\n  password: \"password\",\n  port: 1433,\n  username: \"username\"\n```\n\nNow you can query for users:\n\n```elixir\niex(1)> user = SqlMembershipProvider.User.find_by_user_name(\"JohnDoe\", \"MyApp\")\n%SqlMembershipProvider.User{\n  ...\n}\n\niex(2)> membership = SqlMembershipProvider.Membership.find_by_user_id(user.user_id)\n%SqlMembershipProvider.Membership{\n  ...\n}\n\niex(3)> SqlMembershipProvider.Membership.is_password_valid?(membership, \"password!\")\ntrue\n\niex(4)> profile = SqlMembershipProvider.Profile.find_by_user_id(user.user_id)\n%SqlMembershipProvider.Profile{\n  ...\n}\n\niex(5)> SqlMembershipProvider.Profile.properties(profile)\n%{\n  \"FirstName\" => \"John\",\n  \"LastName\" => \"Doe\",\n  ...\n}\n\niex(6)> roles = SqlMembershipProvider.Role.find_by_user_id(user.user_id)\n[\n  %SqlMembershipProvider.Role{\n    role_name: \"Administrators\",\n    ...\n  }\n]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Running Tests - SqlMembershipProvider","doc":"Clone the repo and fetch its dependencies:\n\n```\n$ git clone https://gitlab.com/horse-racing-labs/sql_membership_provider.git\n$ cd sql_membership_provider\n$ mix deps.get\n```\n\n[Docker Compose](https://docs.docker.com/compose/install/) is required to run a\nsample SQL Server database to run integration tests against.\n\n```\n$ docker-compose up\n$ ./setup-test-database.sh\n$ mix test\n```","ref":"readme.html#running-tests"},{"type":"extras","title":"Future Work - SqlMembershipProvider","doc":"There are tables remaining to be mapped to schemas. Functions to update data\nlike the password and profile properties still need to be implemented.","ref":"readme.html#future-work"},{"type":"extras","title":"Help Wanted - SqlMembershipProvider","doc":"* Only the SHA1 password format is supported. Support should be added for [the\n  remaining password formats](https://docs.microsoft.com/en-us/dotnet/api/system.web.security.membershippasswordformat?view=netframework-4.8).\n* Add support for reading binary properties from profiles","ref":"readme.html#help-wanted"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}